//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Appointment, AppointmentDocument } from '../Appointment';
import { AppointmentService } from '../AppointmentService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Appointment')
@UseBefore(checkApiDisabled(AppointmentBaseController))
export class AppointmentBaseController extends BaseController {
    protected model: Model<AppointmentDocument>;

    protected static readonly _objName: string = 'Appointment';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ,
        create: MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(appointmentService: AppointmentService) {
        super(Appointment, appointmentService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async getAllAppointment(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async getOneAppointment(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async postAppointment(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async patchAppointment(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async deleteAppointment(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsAppointment(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async getCsvExportAppointment(@Res() response, @QueryParams() query) {
        response.attachment(`${AppointmentBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async getXlsxExportAppointment(@Res() response, @QueryParams() query) {
        response.attachment(`${AppointmentBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(AppointmentBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.APPOINTMENT.READ))
    @UseBefore(authenticated)
    public async getPdfExportAppointment(@Res() response, @QueryParams() query) {
        response.attachment(`${AppointmentBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
